(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('angular-enum-list', ['exports', '@angular/core'], factory) :
    (global = global || self, factory(global['angular-enum-list'] = {}, global.ng.core));
}(this, (function (exports, core) { 'use strict';

    var NAMESPACE_NAME = new core.InjectionToken('NAMESPACE_NAME');
    var SEPARATOR_NAME = new core.InjectionToken('SEPARATOR_NAME');

    var SelectorOptionalsModel = /** @class */ (function () {
        function SelectorOptionalsModel(id, name) {
            this.id = id;
            this.name = name;
        }
        return SelectorOptionalsModel;
    }());

    var EnumsPipe = /** @class */ (function () {
        function EnumsPipe(nameSpaceGlobal, separatorGlobal) {
            this.nameSpaceGlobal = nameSpaceGlobal;
            this.separatorGlobal = separatorGlobal;
        }
        EnumsPipe.prototype.transform = function (currentEnum, _a) {
            var _this = this;
            var dictName = _a.dictName, _b = _a.nameSpace, nameSpace = _b === void 0 ? '' : _b, _c = _a.ignored, ignored = _c === void 0 ? [] : _c;
            var currentNameSpace = nameSpace ? nameSpace : this.nameSpaceGlobal;
            var resultArray = [];
            if (currentEnum) {
                Object.keys(currentEnum)
                    .filter(function (x) { return Number.isNaN(parseInt(x, 10)); })
                    .map(function (key) {
                    if (!(ignored.find(function (field) { return field === key; }))) {
                        resultArray.push(new SelectorOptionalsModel(currentEnum[key], "" + currentNameSpace + _this.separatorGlobal + dictName + "." + key));
                    }
                });
            }
            return resultArray;
        };
        return EnumsPipe;
    }());
    EnumsPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'enumList'
                },] },
        { type: core.Injectable }
    ];
    EnumsPipe.ctorParameters = function () { return [
        { type: String, decorators: [{ type: core.Inject, args: [NAMESPACE_NAME,] }] },
        { type: String, decorators: [{ type: core.Inject, args: [SEPARATOR_NAME,] }] }
    ]; };

    var EnumsKeyPipe = /** @class */ (function () {
        function EnumsKeyPipe(nameSpaceGlobal, separatorGlobal) {
            this.nameSpaceGlobal = nameSpaceGlobal;
            this.separatorGlobal = separatorGlobal;
        }
        EnumsKeyPipe.prototype.transform = function (value, _a) {
            var dictName = _a.dictName, currentEnum = _a.currentEnum, nameSpace = _a.nameSpace;
            var currentNameSpace = nameSpace ? nameSpace : this.nameSpaceGlobal;
            var resultKeyPath = '';
            var key = Object.keys(currentEnum).find(function (key) { return currentEnum[key] === value; });
            if (currentEnum && key) {
                resultKeyPath = "" + currentNameSpace + this.separatorGlobal + dictName + "." + key;
            }
            return resultKeyPath;
        };
        return EnumsKeyPipe;
    }());
    EnumsKeyPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'enumKey'
                },] },
        { type: core.Injectable }
    ];
    EnumsKeyPipe.ctorParameters = function () { return [
        { type: String, decorators: [{ type: core.Inject, args: [NAMESPACE_NAME,] }] },
        { type: String, decorators: [{ type: core.Inject, args: [SEPARATOR_NAME,] }] }
    ]; };

    var AngularEnumsListModule = /** @class */ (function () {
        function AngularEnumsListModule() {
        }
        AngularEnumsListModule.forRoot = function (namespace, separator) {
            if (namespace === void 0) { namespace = null; }
            if (separator === void 0) { separator = null; }
            return {
                ngModule: AngularEnumsListModule,
                providers: [
                    {
                        provide: NAMESPACE_NAME,
                        useValue: namespace || 'enums'
                    },
                    {
                        provide: SEPARATOR_NAME,
                        useValue: separator || ':'
                    }
                ]
            };
        };
        return AngularEnumsListModule;
    }());
    AngularEnumsListModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        EnumsPipe,
                        EnumsKeyPipe
                    ],
                    exports: [
                        EnumsPipe,
                        EnumsKeyPipe
                    ],
                    providers: [
                        AngularEnumsListModule,
                        EnumsPipe,
                        EnumsKeyPipe
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AngularEnumsListModule = AngularEnumsListModule;
    exports.EnumsKeyPipe = EnumsKeyPipe;
    exports.EnumsPipe = EnumsPipe;
    exports.NAMESPACE_NAME = NAMESPACE_NAME;
    exports.SEPARATOR_NAME = SEPARATOR_NAME;
    exports.SelectorOptionalsModel = SelectorOptionalsModel;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-enum-list.umd.js.map
